#pragma once 

#include "dubins.h"

using namespace opendubins;

struct GdipAPI{
    Dubins maneuver;   
    State tmp_state;
};


#ifdef __cplusplus
extern "C" {
#endif

    GdipAPI* new_GdipAPI();

    void set_configurations(GdipAPI* api, double start[3], double end[3], double radius);
    void set_configurations_dip(GdipAPI* api, double point1[2], double interval1[2], double point2[2], double interval2[2], double radius);
    void set_configurations_gdip(GdipAPI* api, double point1[2], double interval1[2], double radius1, double point2[2], double interval2[2], double radius2, double radius);

    double get_length(GdipAPI* api);
  
    void sample_state_to_tmp(GdipAPI* api, double distance);

    double get_tmp_x(GdipAPI* api);
    double get_tmp_y(GdipAPI* api);
    double get_tmp_theta(GdipAPI* api);

    void destruct(GdipAPI* api);

#ifdef __cplusplus
}
#endif

